include $(MAKE_INCLUDE_DIR)/Common.mk

# Qt bin dir in Path!

QT_INC=/usr/include/x86_64-linux-gnu/qt6
# QT_LIBS=/usr/lib/x86_64-linux-gnu
QT_BIN=/usr/lib/qt6/libexec
MOC = $(QT_BIN)/moc
UIC = $(QT_BIN)/uic
RCC = $(QT_BIN)/rcc


ifeq ($(MOC),)
$(error Didn't find Moc. Add Qt-Bin-Dir to Path!)
endif

#Compile options needed for QtCore
# !! WARNING !!
# Qt6 doesn't use pkg-config or qmake anymore but uses CMAKE instead...
# so try to insert flags manually
# before: pkg-config --cflags --libs Qt5Core

QTCORE_CFLAGS       = -I$(QT_INC) -I$(QT_INC)/QtCore
QTCORE_LIBS         = -lQt6Core
QTGUI_CFLAGS        = -I$(QT_INC) -I$(QT_INC)/QtGui -I$(QT_INC) -I$(QT_INC)/QtCore
QTGUI_LIBS          = -lQt6Gui -lQt6Core
QTWIDGETS_CFLAGS    = -I$(QT_INC) -I$(QT_INC)/QtWidgets -I$(QT_INC) -I$(QT_INC)/QtCore
QTWIDGETS_LIBS      = -lQt6Gui -lQt6Widgets

#Operations we have to do in order to prepare QtXZ
QtCore:
QtGui:
QtWidgets:

